/* midori-uri.c generated by valac 0.12.1, the Vala compiler
 * generated from midori-uri.vala, do not modify */

/*
 Copyright (C) 2011 Christian Dywan <christian@twotoasts.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define MIDORI_TYPE_URI (midori_uri_get_type ())
#define MIDORI_URI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_URI, MidoriURI))
#define MIDORI_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_URI, MidoriURIClass))
#define MIDORI_IS_URI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_URI))
#define MIDORI_IS_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_URI))
#define MIDORI_URI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_URI, MidoriURIClass))

typedef struct _MidoriURI MidoriURI;
typedef struct _MidoriURIClass MidoriURIClass;
typedef struct _MidoriURIPrivate MidoriURIPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MidoriURI {
	GObject parent_instance;
	MidoriURIPrivate * priv;
};

struct _MidoriURIClass {
	GObjectClass parent_class;
};


static gpointer midori_uri_parent_class = NULL;

gchar* g_hostname_to_unicode (const gchar* hostname);
gchar* g_hostname_to_ascii (const gchar* hostname);
GType midori_uri_get_type (void) G_GNUC_CONST;
enum  {
	MIDORI_URI_DUMMY_PROPERTY
};
gchar* midori_uri_parse_hostname (const gchar* uri, gchar** path);
gchar* midori_uri_parse (const gchar* uri, gchar** path);
gchar* midori_uri_to_ascii (const gchar* uri);
gchar* midori_uri_unescape (const gchar* uri);
gchar* midori_uri_format_for_display (const gchar* uri);
gchar* midori_uri_for_search (const gchar* uri, const gchar* keywords);
gboolean midori_uri_is_blank (const gchar* uri);
gboolean midori_uri_is_http (const gchar* uri);
gboolean midori_uri_is_resource (const gchar* uri);
gboolean midori_uri_is_location (const gchar* uri);
gboolean midori_uri_is_email (const gchar* uri);
gboolean midori_uri_is_ip_address (const gchar* uri);
gboolean midori_uri_is_valid (const gchar* uri);
GChecksumType midori_uri_get_fingerprint (const gchar* uri, gchar** checksum, gchar** label);
MidoriURI* midori_uri_new (void);
MidoriURI* midori_uri_construct (GType object_type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


static const gchar* string_offset (const gchar* self, glong offset) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = (const gchar*) (((gchar*) self) + offset);
	return result;
}


gchar* midori_uri_parse_hostname (const gchar* uri, gchar** path) {
	gchar* _path = NULL;
	gchar* result = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* hostname;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp14_;
	if (uri == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (uri);
		result = _tmp0_;
		if (path) {
			*path = _path;
		} else {
			_g_free0 (_path);
		}
		return result;
	}
	_tmp1_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '/');
	hostname = _tmp1_;
	if (hostname == NULL) {
		_tmp3_ = TRUE;
	} else {
		gchar _tmp4_;
		_tmp4_ = string_get (hostname, (glong) 1);
		_tmp3_ = _tmp4_ != '/';
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = g_utf8_strchr (hostname, (gssize) (-1), (gunichar) ' ');
		_tmp2_ = _tmp5_ != NULL;
	}
	if (_tmp2_) {
		result = NULL;
		if (path) {
			*path = _path;
		} else {
			_g_free0 (_path);
		}
		return result;
	}
	_tmp6_ = string_offset (hostname, (glong) 2);
	hostname = _tmp6_;
	if ((&_path) != NULL) {
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp7_ = g_utf8_strchr (hostname, (gssize) (-1), (gunichar) '/');
		_tmp8_ = g_strdup (_tmp7_);
		_g_free0 (_path);
		_path = _tmp8_;
		if (_path != NULL) {
			gchar** _tmp9_;
			gchar** _tmp10_ = NULL;
			gchar** _tmp11_;
			gint _tmp11__length1;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp10_ = _tmp9_ = g_strsplit (hostname, "/", 0);
			_tmp11_ = _tmp10_;
			_tmp11__length1 = _vala_array_length (_tmp9_);
			_tmp12_ = g_strdup (_tmp11_[0]);
			_tmp13_ = _tmp12_;
			_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
			result = _tmp13_;
			if (path) {
				*path = _path;
			} else {
				_g_free0 (_path);
			}
			return result;
		}
	}
	_tmp14_ = g_strdup (hostname);
	result = _tmp14_;
	if (path) {
		*path = _path;
	} else {
		_g_free0 (_path);
	}
	return result;
}


gchar* midori_uri_parse (const gchar* uri, gchar** path) {
	gchar* _path = NULL;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp1_ = midori_uri_parse_hostname (uri, &_tmp0_);
	_g_free0 (_path);
	_path = _tmp0_;
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (uri);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp3_;
	}
	result = _tmp2_;
	if (path) {
		*path = _path;
	} else {
		_g_free0 (_path);
	}
	return result;
}


gchar* midori_uri_to_ascii (const gchar* uri) {
	gchar* result = NULL;
	gchar* proto;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gchar* path;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp11_;
	gchar* hostname;
	gchar* _tmp12_ = NULL;
	gchar* encoded;
	gchar* _tmp23_;
	g_return_val_if_fail (uri != NULL, NULL);
	proto = NULL;
	_tmp1_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '/');
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ':');
		_tmp0_ = _tmp2_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** _tmp3_;
		gchar** _tmp4_ = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		_tmp4_ = _tmp3_ = g_strsplit (uri, "://", 0);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _vala_array_length (_tmp3_);
		_tmp6_ = g_strdup (_tmp5_[0]);
		_g_free0 (proto);
		proto = _tmp6_;
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	}
	path = NULL;
	_tmp8_ = midori_uri_parse_hostname (uri, &_tmp7_);
	_g_free0 (path);
	path = _tmp7_;
	_tmp9_ = _tmp8_;
	if (_tmp9_ == NULL) {
		gchar* _tmp10_;
		_tmp10_ = g_strdup (uri);
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp10_;
	}
	_tmp11_ = g_strdup (_tmp9_);
	hostname = _tmp11_;
	_tmp12_ = g_hostname_to_ascii (hostname);
	encoded = _tmp12_;
	if (encoded != NULL) {
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		_tmp13_ = g_strdup (proto);
		_tmp14_ = _tmp13_;
		if (_tmp14_ == NULL) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			_g_free0 (_tmp14_);
			_tmp14_ = _tmp15_;
		}
		if (proto != NULL) {
			_tmp16_ = "://";
		} else {
			_tmp16_ = "";
		}
		_tmp17_ = g_strconcat (_tmp14_, _tmp16_, NULL);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp18_, encoded, NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat (_tmp20_, path, NULL);
		_tmp22_ = _tmp21_;
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		result = _tmp22_;
		_g_free0 (_tmp14_);
		_g_free0 (encoded);
		_g_free0 (hostname);
		_g_free0 (_tmp9_);
		_g_free0 (path);
		_g_free0 (proto);
		return result;
	}
	_tmp23_ = g_strdup (uri);
	result = _tmp23_;
	_g_free0 (encoded);
	_g_free0 (hostname);
	_g_free0 (_tmp9_);
	_g_free0 (path);
	_g_free0 (proto);
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	regex = _tmp3_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch0_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch0_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* midori_uri_unescape (const gchar* uri) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp6_;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp1_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '%');
	if (_tmp1_ != NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ');
		_tmp0_ = _tmp2_ != NULL;
	}
	if (_tmp0_) {
		gchar* _tmp3_ = NULL;
		gchar* unescaped;
		gchar* _tmp5_ = NULL;
		_tmp3_ = g_uri_unescape_string (uri, "+");
		unescaped = _tmp3_;
		if (unescaped == NULL) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup (uri);
			result = _tmp4_;
			_g_free0 (unescaped);
			return result;
		}
		_tmp5_ = string_replace (unescaped, " ", "%20");
		result = _tmp5_;
		_g_free0 (unescaped);
		return result;
	}
	_tmp6_ = g_strdup (uri);
	result = _tmp6_;
	return result;
}


gchar* midori_uri_format_for_display (const gchar* uri) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp13_;
	if (uri != NULL) {
		gboolean _tmp1_;
		_tmp1_ = g_str_has_prefix (uri, "http://");
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp2_ = NULL;
		gchar* unescaped;
		gchar* path = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* hostname;
		gchar* _tmp8_ = NULL;
		gchar* decoded;
		_tmp2_ = midori_uri_unescape (uri);
		unescaped = _tmp2_;
		if (unescaped == NULL) {
			gchar* _tmp3_;
			_tmp3_ = g_strdup (uri);
			result = _tmp3_;
			_g_free0 (unescaped);
			return result;
		} else {
			gboolean _tmp4_;
			_tmp4_ = g_utf8_validate (unescaped, (gssize) (-1), NULL);
			if (!_tmp4_) {
				gchar* _tmp5_;
				_tmp5_ = g_strdup (uri);
				result = _tmp5_;
				_g_free0 (unescaped);
				return result;
			}
		}
		_tmp7_ = midori_uri_parse_hostname (unescaped, &_tmp6_);
		_g_free0 (path);
		path = _tmp6_;
		hostname = _tmp7_;
		_tmp8_ = g_hostname_to_unicode (hostname);
		decoded = _tmp8_;
		if (decoded != NULL) {
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp9_ = g_strconcat ("http://", decoded, NULL);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strconcat (_tmp10_, path, NULL);
			_tmp12_ = _tmp11_;
			_g_free0 (_tmp10_);
			result = _tmp12_;
			_g_free0 (decoded);
			_g_free0 (hostname);
			_g_free0 (path);
			_g_free0 (unescaped);
			return result;
		}
		result = unescaped;
		_g_free0 (decoded);
		_g_free0 (hostname);
		_g_free0 (path);
		return result;
	}
	_tmp13_ = g_strdup (uri);
	result = _tmp13_;
	return result;
}


gchar* midori_uri_for_search (const gchar* uri, const gchar* keywords) {
	gchar* result = NULL;
	gchar* _tmp1_ = NULL;
	gchar* escaped;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp4_;
	g_return_val_if_fail (keywords != NULL, NULL);
	if (uri == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (keywords);
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_uri_escape_string (keywords, ":/", TRUE);
	escaped = _tmp1_;
	_tmp2_ = strstr (uri, "%s");
	if (_tmp2_ != NULL) {
		gchar* _tmp3_ = NULL;
		_tmp3_ = g_strdup_printf (uri, escaped);
		result = _tmp3_;
		_g_free0 (escaped);
		return result;
	}
	_tmp4_ = g_strconcat (uri, escaped, NULL);
	result = _tmp4_;
	_g_free0 (escaped);
	return result;
}


gboolean midori_uri_is_blank (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (uri != NULL) {
		_tmp1_ = g_strcmp0 (uri, "") != 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = g_str_has_prefix (uri, "about:");
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = !_tmp0_;
	return result;
}


gboolean midori_uri_is_http (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (uri != NULL) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		_tmp2_ = g_str_has_prefix (uri, "http://");
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp3_;
			_tmp3_ = g_str_has_prefix (uri, "https://");
			_tmp1_ = _tmp3_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean midori_uri_is_resource (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (uri != NULL) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		_tmp2_ = midori_uri_is_http (uri);
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_;
			_tmp4_ = g_str_has_prefix (uri, "data:");
			if (_tmp4_) {
				const gchar* _tmp5_ = NULL;
				_tmp5_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ';');
				_tmp3_ = _tmp5_ != NULL;
			} else {
				_tmp3_ = FALSE;
			}
			_tmp1_ = _tmp3_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean midori_uri_is_location (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (uri != NULL) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_ = NULL;
		_tmp7_ = strstr (uri, "://");
		if (_tmp7_ != NULL) {
			const gchar* _tmp8_ = NULL;
			_tmp8_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ');
			_tmp6_ = _tmp8_ == NULL;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			_tmp5_ = TRUE;
		} else {
			gboolean _tmp9_;
			_tmp9_ = midori_uri_is_http (uri);
			_tmp5_ = _tmp9_;
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			gboolean _tmp10_;
			_tmp10_ = g_str_has_prefix (uri, "about:");
			_tmp4_ = _tmp10_;
		}
		if (_tmp4_) {
			_tmp3_ = TRUE;
		} else {
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_;
			_tmp12_ = g_str_has_prefix (uri, "data:");
			if (_tmp12_) {
				const gchar* _tmp13_ = NULL;
				_tmp13_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ';');
				_tmp11_ = _tmp13_ != NULL;
			} else {
				_tmp11_ = FALSE;
			}
			_tmp3_ = _tmp11_;
		}
		if (_tmp3_) {
			_tmp2_ = TRUE;
		} else {
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
			_tmp15_ = g_str_has_prefix (uri, "geo:");
			if (_tmp15_) {
				const gchar* _tmp16_ = NULL;
				_tmp16_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ',');
				_tmp14_ = _tmp16_ != NULL;
			} else {
				_tmp14_ = FALSE;
			}
			_tmp2_ = _tmp14_;
		}
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp17_;
			_tmp17_ = g_str_has_prefix (uri, "javascript:");
			_tmp1_ = _tmp17_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean midori_uri_is_email (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (uri != NULL) {
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_ = NULL;
		_tmp3_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '@');
		if (_tmp3_ != NULL) {
			_tmp2_ = TRUE;
		} else {
			gboolean _tmp4_;
			_tmp4_ = g_str_has_prefix (uri, "mailto:");
			_tmp2_ = _tmp4_;
		}
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = strstr (uri, "://");
		_tmp0_ = _tmp5_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean midori_uri_is_ip_address (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (uri != NULL) {
		gchar _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = string_get (uri, (glong) 0);
		_tmp3_ = g_ascii_isdigit (_tmp2_);
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		_tmp5_ = g_utf8_strchr (uri, (gssize) 4, (gunichar) '.');
		if (_tmp5_ != NULL) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp6_ = NULL;
			_tmp6_ = g_utf8_strchr (uri, (gssize) 4, (gunichar) ':');
			_tmp4_ = _tmp6_ != NULL;
		}
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean midori_uri_is_valid (const gchar* uri) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (uri != NULL) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ');
		_tmp1_ = _tmp2_ == NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		_tmp4_ = midori_uri_is_location (uri);
		if (_tmp4_) {
			_tmp3_ = TRUE;
		} else {
			const gchar* _tmp5_ = NULL;
			_tmp5_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '.');
			_tmp3_ = _tmp5_ != NULL;
		}
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


GChecksumType midori_uri_get_fingerprint (const gchar* uri, gchar** checksum, gchar** label) {
	gchar* _checksum = NULL;
	gchar* _label = NULL;
	GChecksumType result = 0;
	const gchar* delimiter;
	const gchar* _tmp0_ = NULL;
	const gchar* display;
	GChecksumType type;
	const gchar* _tmp1_ = NULL;
	const gchar* fragment;
	g_return_val_if_fail (uri != NULL, 0);
	delimiter = "#!md5!";
	_tmp0_ = _ ("MD5-Checksum:");
	display = _tmp0_;
	type = G_CHECKSUM_MD5;
	_tmp1_ = strstr (uri, delimiter);
	fragment = _tmp1_;
	if (fragment == NULL) {
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		delimiter = "#!sha1!";
		_tmp2_ = _ ("SHA1-Checksum:");
		display = _tmp2_;
		type = G_CHECKSUM_SHA1;
		_tmp3_ = strstr (uri, delimiter);
		fragment = _tmp3_;
	}
	if (fragment == NULL) {
		type = (GChecksumType) G_MAXINT;
		display = NULL;
	}
	if ((&_checksum) != NULL) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp7_;
		if (fragment != NULL) {
			gint _tmp5_;
			const gchar* _tmp6_ = NULL;
			_tmp5_ = strlen (delimiter);
			_tmp6_ = string_offset (fragment, (glong) _tmp5_);
			_tmp4_ = _tmp6_;
		} else {
			_tmp4_ = NULL;
		}
		_tmp7_ = g_strdup (_tmp4_);
		_g_free0 (_checksum);
		_checksum = _tmp7_;
	}
	if ((&_label) != NULL) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup (display);
		_g_free0 (_label);
		_label = _tmp8_;
	}
	result = type;
	if (checksum) {
		*checksum = _checksum;
	} else {
		_g_free0 (_checksum);
	}
	if (label) {
		*label = _label;
	} else {
		_g_free0 (_label);
	}
	return result;
}


MidoriURI* midori_uri_construct (GType object_type) {
	MidoriURI * self = NULL;
	self = (MidoriURI*) g_object_new (object_type, NULL);
	return self;
}


MidoriURI* midori_uri_new (void) {
	return midori_uri_construct (MIDORI_TYPE_URI);
}


static void midori_uri_class_init (MidoriURIClass * klass) {
	midori_uri_parent_class = g_type_class_peek_parent (klass);
}


static void midori_uri_instance_init (MidoriURI * self) {
}


GType midori_uri_get_type (void) {
	static volatile gsize midori_uri_type_id__volatile = 0;
	if (g_once_init_enter (&midori_uri_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriURIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_uri_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriURI), 0, (GInstanceInitFunc) midori_uri_instance_init, NULL };
		GType midori_uri_type_id;
		midori_uri_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriURI", &g_define_type_info, 0);
		g_once_init_leave (&midori_uri_type_id__volatile, midori_uri_type_id);
	}
	return midori_uri_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



